<?php
namespace DiviBooster\PhpCode;

class Attributes {
	
	private $atts;
	
	static function fromString($text='') {
		// Based on WP's shortcode_parse_atts function, but modified to allow unclosed angle brackets
		$atts = array();
		$pattern = get_shortcode_atts_regex();
		$text = preg_replace("/[\x{00a0}\x{200b}]+/u", " ", $text);
		if ( preg_match_all($pattern, $text, $match, PREG_SET_ORDER) ) {
			foreach ($match as $m) {
				if (!empty($m[1]))
					$atts[strtolower($m[1])] = stripcslashes($m[2]);
				elseif (!empty($m[3]))
					$atts[strtolower($m[3])] = stripcslashes($m[4]);
				elseif (!empty($m[5]))
					$atts[strtolower($m[5])] = stripcslashes($m[6]);
				elseif (isset($m[7]) && strlen($m[7]))
					$atts[] = stripcslashes($m[7]);
				elseif (isset($m[8]) && strlen($m[8]))
					$atts[] = stripcslashes($m[8]);
				elseif (isset($m[9]))
					$atts[] = stripcslashes($m[9]);
			}
		} 
		return new self($atts);
	}
	
	function __construct(array $atts) {
		$this->atts = $atts;
	}
	
	function toArray() {
		return $this->atts;
	}
	
	function __toString() {
		return dbphp_shortcode_build_atts_str($this->atts);
	}
}



// Rebuilds attribute string from array
if (!function_exists('dbphp_shortcode_build_atts_str')) {
	function dbphp_shortcode_build_atts_str($atts) {
		$atts_str = '';
		if (is_array($atts)) {
			foreach($atts as $k=>$v) {
				$v = htmlentities($v);
				$v = str_replace(array("[", "]"), array("&#91;", "&#93;"), $v); // Escape square brackets
				$atts_str .= ' '.$k.'="'.$v.'"';
			}
		}
		$atts_str = ltrim($atts_str);
		return apply_filters('dbphp_shortcode_build_atts_str', $atts_str, $atts);
	}
}