<?php
namespace DiviBooster\PhpCode;

// Representation of the PHP module shortcode
class Shortcode {
	
	var $atts;
	var $content = '';
	var $verified = false;
	
	static function fromPregMatch($match) {
		$atts = '';
		if (isset($match[3]) && is_string($match[3])) {
			$atts = $match[3];
		}
		$content = '';
		if (isset($match[5]) && is_string($match[5])) {
			$content = $match[5];
		}
		return new self(Attributes::fromString($atts), $content);
	}
	
	function __construct(Attributes $atts, $content='') {
		$this->atts = $atts;
		$this->content = $content;
	}
	
	function __get($name) {
		if ($name === 'code') {
			$atts = $this->atts->toArray();
			return isset($atts['code'])?$atts['code']:'';
		}
	}
	
	function __set($name, $val) {
		if ($name === 'code') {
			$atts = $this->atts->toArray();
			$atts['code'] = $val;
			$this->atts = new Attributes($atts);
		}
	}

    function withAttribute($name, $val) {
        $atts = $this->atts->toArray();
        $atts[$name] = $val;
        return new self(new Attributes($atts), $this->content);}
	
	function atts_str() {
		return (string) $this->atts;
	}
	
	function render() {
		return '[et_pb_db_php_code '.$this->atts_str().']'.$this->content.'[/et_pb_db_php_code]';
	}
}

