<?php 
namespace DiviBooster\PhpCode;

add_filter('wp_insert_post_data', __NAMESPACE__.'\\dbphp_apply_filter_to_post_content');
add_filter('dbphp_insert_post_content', 'stripslashes');
add_filter('dbphp_insert_post_content', __NAMESPACE__.'\\dbphp_filter_php_code_shortcodes_in_content');
add_filter('dbphp_insert_post_content', 'addslashes');
add_action('wp_ajax_et_fb_ajax_save', __NAMESPACE__.'\\dbphp_remove_slash_filters', 9); 
add_action('wp_ajax_et_fb_update_layout', __NAMESPACE__.'\\dbphp_remove_slash_filters', 9); 

// Disable Divi's verification check (which fails if the content changes) since filtering is intended to change the content
add_action('et_fb_ajax_save_verification_result', '__return_true');

// Remove insert filter if saving layout from classic builder 
add_action('wp_ajax_et_pb_save_layout', __NAMESPACE__.'\\dbphp_remove_insert_post_data_filter', 9);
add_action('wp_ajax_et_pb_update_layout', __NAMESPACE__.'\\dbphp_remove_insert_post_data_filter', 9);

function dbphp_remove_insert_post_data_filter() {
	remove_filter('wp_insert_post_data', __NAMESPACE__.'\\dbphp_apply_filter_to_post_content');
}

function dbphp_apply_filter_to_post_content($data) {
	// Remove calling filter as visual builder calls it multiple times on the same save
	remove_filter('wp_insert_post_data', __NAMESPACE__.'\\dbphp_apply_filter_to_post_content');
    $content = isset($data['post_content'])?$data['post_content']:'';
	$content = apply_filters('dbphp_insert_post_content', $content);
	$data['post_content'] = $content;
	return $data;
}

function dbphp_remove_slash_filters() {
	remove_filter('dbphp_insert_post_content', 'stripslashes');
	remove_filter('dbphp_insert_post_content', 'addslashes');
}

function dbphp_filter_php_code_shortcodes_in_content($content) {
	$shortcode_regex = get_shortcode_regex(array('et_pb_db_php_code'));
	$content = preg_replace_callback('/'.$shortcode_regex.'/s', __NAMESPACE__.'\\dbphp_filter_php_code_shortcode', $content);
	return $content;
}
function dbphp_filter_php_code_shortcode($preg_replace_callback_match) {
	$shortcode = \DiviBooster\PhpCode\Shortcode::fromPregMatch($preg_replace_callback_match);
	$shortcode = apply_filters('et_pb_db_php_code_pre_save', $shortcode);
	return $shortcode->render();
}