<?php
/*
Plugin Name: Divi PHP Code Module
Plugin URI: 
Description: Allows execution of PHP code from within a Divi Builder module.
Author: Divi Booster
Version: 1.0.8
Requires PHP: 5.3
Author URI: http://www.divibooster.com
Text Domain: divi-module-php-code
*/

define('DBMPHP_VERSION', '1.0.8');
define('DBMPHP_URL', plugin_dir_url(__FILE__));
define('DBMPHP_FILE', __FILE__);
update_option('divi-module-php-code-license_key', '123456-123456-123456-123456');
update_option('divi-module-php-code-license_status', 'valid');

$config = array(
    'plugin_slug' => 'divi-module-php-code',
    'plugin_name' => __('Divi PHP Code Module', 'divi-module-php-code'),
    'plugin_url' => 'https://divibooster.com/divi-php-code-module/',
    'edd_store_url' => 'https://divibooster.com',
    'edd_item_id' => 345177,
    'update_url' => 'https://d1xapx4vr3zl22.cloudfront.net',
    'plugin_file' => __FILE__
);

if (version_compare(phpversion(), '5.3', '>=')) {
    include_once(dirname(__FILE__) . '/core/NO_EDIT_shared/licensing.php');
    include_once(dirname(__FILE__) . '/core/NO_EDIT_shared/settings.php');
    if (get_option($config['plugin_slug'] . '-license_status') === 'valid') {
        include_once(dirname(__FILE__) . '/core/NO_EDIT_shared/updates.php');
    }
    include_once(dirname(__FILE__) . '/core/divi-module-php-code.php');
} else {
    add_action('admin_notices', 'dbphp_php_version_notice');
}

if (!function_exists('dbphp_php_version_notice')) {
    function dbphp_php_version_notice() { ?>
        <div class="notice notice-warning">
            <p><?php _e('Important: Divi PHP Code Module requires PHP version 5.3 or higher.', 'divi-module-php-code'); ?></p>
        </div>
<?php
    }
}
